#include<iostream>
using namespace std;

int N, U, V, Q, M, br[100001], br_prqko[100001]={0}, pr[100001][1000];

int tursen(int segch)
{
    if(br[segch]!=-1)
    {
        return br[segch];
    }
    br[segch]=0;
    for(int i=0;i<br_prqko[segch];i++)
    {
        br[segch]+=tursen(pr[segch][i])+1;
    }
    return br[segch];
}

int main()
{
    cin>>N;
    for(int i=1;i<N;i++)
    {
        cin>>U>>V;
        pr[U][br_prqko[U]]=V;
        br_prqko[U]++;
    }
    for(int i=0;i<=N;i++)
    {
        br[i]=-1;
    }
    cin>>Q;
    for(int i=0;i<Q;i++)
    {
        cin>>M;
        cout<<tursen(M)<<endl;
    }
    return 0;
}